Here is the mashup link (the problems are from Codeforces' problem set).
A.Abenezer's String Problem
To solve the problem we need to find the character with the highest alphabetical order in our string, since Abenezer will need at least that alphabet size and won't need more. To do this iterate through the string and find the character with the highest alphabetical order. Output the maximum alphabetical order found. The solution can be done in $$$O(n)$$$.
t = int(input())
for _ in range(t):
n = int(input())
s = input()
ma = 0
for ch in s:
ma = max(ma, ord(ch))
print(ma - 96)
B. Ruth Wossen The Monster Killer
We are interested in the sum of a interval of a given sequence. This can be done by calculating the prefix sum of the sequence beforehand. That is,$$$sv_i = \sum_{j=1}^{i} (v_j)$$$ let . The sum of numbers in the interval $$$[l, r]$$$ would then be $$$sv_r - sv_{l - 1}$$$. we can sort sequence $$$v$$$ to obtain sequence $$$u$$$. We can deal with sequence $$$u$$$ likewise.
Preprocessing takes $$$O(n)$$$ time, and answering a query is only $$$O(1)$$$. The total complexity would be $$$O(nlogn + q)$$$.
n = int(input())
nums = list(map(int, input().split()))
q = int(input())
def calc_prefix(arr):
res = [arr[0]]
for i in range(1, len(arr)):
res.append(res[-1] + arr[i])
return res
sorted_nums = sorted(nums)
arr1 = calc_prefix(nums)
arr2 = calc_prefix(sorted(nums))
for _ in range(q):
a, l, r = map(int, input().split())
if a == 1:
print(arr1[r - 1] - arr1[l - 1] + nums[l - 1])
else:
print(arr2[r - 1] - arr2[l - 1] + sorted_nums[l - 1])
C. Nahom Needs Help
First, we need to determine how many times each operation will be performed. For instance, if our query is $$$1, 3$$$, and $$$2, 5$$$ then $$$2$$$ and $$$3$$$ will be done twice since they fall within two ranges, while the rest will be done once. To calculate this, we can use a prefix sum with range updates.
Next, for each operation $$$l, r, d, and$$$ $$$v$$$ (where $$$v$$$ represents the number of times it will be performed), we'll increment all elements from $$$l$$$ to $$$r$$$ inclusive by $$$d*v$$$. This can also be efficiently computed using a prefix sum with range updates.
prefix sum with range updates: Let's think about a somewhat easier problem first. What if we were asked to add a constant value to the suffix of the array starting at index l, for multiple queries? Instead of updating the whole suffix for each query, we can only increment the first index of the suffix for each query, $$$i.e a[l]+=k$$$. Then after all queries, we take the prefix sum of the whole array. This will "propagate" our increments till the end of the array and thus our task of updating the whole suffix is accomplished at the end, after taking prefix sums. Now, what about updating the range $$$[l…r]$$$? Can you decompose this range update as $2 suffix updates? It can be decomposed as such:
if you need to increment the range $$$[l…r]$$$ by $$$k$$$, you can increment the suffix starting at index $$$l$$$ by $$$k$$$ and decrement the suffix starting at index $$$r+1$$$ by $$$k$$$, i.e perform the operations $$$a[l]+=k$$$ and $$$a[r+1]−=k$$$ for each query and then take the prefix sum of the array as before.
A visual summary:
n, m, k = map(int, input().split())
a = list(map(int, input().split()))
op = []
for _ in range(m):
op.append(list(map(int, input().split())))
q = [0]*(m+1)
for _ in range(k):
l, r = (map(int, input().split()))
q[l-1] += 1
q[r] -= 1
for i in range(m-1):
q[i+1] += q[i]
update = [0]*(n+1)
for query in range(m):
l,r,d = op[query]
update[l - 1] += d*q[query]
update[r] -= d*q[query]
for i in range(n-1):
update[i+1] += update[i]
for i in range(n):
a[i] += update[i]
print(*a)
D. The Keeper Game
There is always one sheep that shouldn't move.
Let's denote by k the number of sheep in the string, and by $$$x_1,x_2,…,x_k$$$ $$$(1≤x_1<x_2<…<x_k≤n)$$$ their positions in the string. Note that in the optimal solution the sheep with the number $$$m=⌈n2⌉$$$ will not make moves. This can be proved by considering the optimal solution in which the sheep with the number m makes at least one move. if it moves to the right all sheep that are to the left of $$$x_m$$$( $$$x_1,x_2,…,x_{m-1}$$$) will move by one to the right but not all the sheep that are on the left side of $$$x_m$$$( $$$x_{m+1},x{m+2},…,x_k$$$) will decrease their movement by one and same thing if the $$$m-th$$$ sheep move to the left. So we can conclude that this solution is not optimal. Consider sheep with numbers from i=1 to n
Then the final position of the $$$i-th$$$ sheep will be $$$x_m−m+i$$$, and the answer will be $$$\sum\limits_{k = 0}^n |xi−(xm−m+i)|$$$, since all the sheep have to move from $$$x_i$$$ to $$$x_m-m+i$$$.
testcases = int(input())
for _ in range(testcases)
n = int(input())
s = input().strip()
cnt = s.count('*') # total count of sheeps
pos = -1 # hold the position of the mth sheep
cur = -1
for i in range(n):
if s[i] == '*':
cur += 1
if cur == cnt // 2:
pos = i
ans = 0
# pos -> xm cnt//2-> and i =-> 0
cur = pos - cnt // 2
for i in range(n):
if s[i] == '*':
ans += abs(cur - i)
cur += 1
print(ans)
E. Is Nardos's Gift for Timket Bad?
Calculate the total number of participants that can join the contest for hour 1.
Use the sliding window algorithm to calculate the rest.
For hour 1 at the first timezone, it will be hour 2 for the second, and so forth. participants from timezone $$$s$$$ to timezone $$$f - 1$$$ are eligible to join the contest. For the second hour, it becomes $$$s - 1 - f - 2$$$, and so forth. If we have the count of contestants participating in the first hour, we can use a sliding window technique to compute the rest. Our answer is updated only when we discover a larger sum.
$$$Note$$$ Since the array is circular and our pointer might be out of bound we have to use mod to correct it
n = int(input())
arr = list(map(int , input().split()))
s , f = map(int , input().split())
ans = 1
# The window when time = 1 at first timezone
cur_total = sum(arr[s - 1:f - 1])
left = s - 1 # the leftmost element in our window
right = f - 2 # the rightmost element in our window
max_value = cur_total
for i in range(2 , n + 2):
cur_total -= arr[right]
right -= 1
left -= 1
# When left and right < 0 that means they start iterating from the back
cur_total += arr[left]
if cur_total > max_value:
ans = i
max_value = cur_total
print(ans if ans else n)